//+
Include "ring3d_id.geo";

lc = DefineNumber[ 0.05, Name "Parameters/lc" ];

lc2 = lc;
lb = 1.0;
core_rad = 0.18;
rt2 = 0.25;
rt1 = 0.2;
bz = 0.0;
ht = 0.25;

er = 0.3;
eh = 0.1;
eg = 0.01;
eb = -eg;
// inductor tube
bz = 0.0;
p = newp;
Point(p) = {0, 0, bz, lc2};
Point(p+1) = {rt1, 0, bz, lc2};
Point(p+2) = {0, rt1, bz, lc2};
Point(p+3) = {-rt1, 0, bz, lc2};
Point(p+4) = {0, -rt1, bz, lc2};
Point(p+5) = {rt2, 0, bz, lc2};
Point(p+6) = {0, rt2, bz, lc2};
Point(p+7) = {-rt2, 0, bz, lc2};
Point(p+8) = {0, -rt2, bz, lc2};
c = newc;
Circle(c) = {p+1, p, p+2};
Circle(c+1) = {p+2, p, p+3};
Circle(c+2) = {p+3, p, p+4};
Circle(c+3) = {p+4, p, p+1};
Circle(c+4) = {p+5, p, p+6};
Circle(c+5) = {p+6, p, p+7};
Circle(c+6) = {p+7, p, p+8};
Circle(c+7) = {p+8, p, p+5};
ll = newll;
Line Loop(ll) = {c+4, c+5, c+6, c+7, -c, -(c+1), -(c+2), -(c+3)};
s = news;
Plane Surface(s) = {ll};
tmp[] = Extrude {0,0,ht}{ Surface{s}; };
vol_coil = tmp[1];
//+
// core
p = newp;
Point(p) = {0, 0, 0, lc};
Point(p+1) = {core_rad, 0, 0, lc};
Point(p+2) = {0, core_rad, 0, lc};
Point(p+3) = {-core_rad, 0, 0, lc};
Point(p+4) = {0, -core_rad, 0, lc};
//+
c = newc;
Circle(c) = {p+1, p, p+2};
Circle(c+1) = {p+2, p, p+3};
Circle(c+2) = {p+3, p, p+4};
Circle(c+3) = {p+4, p, p+1};
//+
ll = newll;
Line Loop(ll) = {c, c+1, c+2, c+3};
//+
s = news;
Surface(s) = {ll};
//+
tmp[] = Extrude {0, 0, 0.25} { Surface{s}; };
vol_core = tmp[1];
//
//+
p = newp;
Point(p) = {-lb/2,-lb/2,-lb/2,lc};
Point(p+1) = {lb/2,-lb/2,-lb/2,lc};
Point(p+2) = {lb/2,lb/2,-lb/2,lc};
Point(p+3) = {-lb/2,lb/2,-lb/2,lc};
l = newl;
Line(l) = {p, p+1};
Line(l+1) = {p+1, p+2};
Line(l+2) = {p+2, p+3};
Line(l+3) = {p+3, p};
ll = newll;
Line Loop(ll) = {l,l+1,l+2,l+3};
s = news;
Surface(s) = {ll};
tmp[] = Extrude {0,0,lb} { Surface{s}; };
vol_box = tmp[1];
//
//
// eddy plate
p = newp;
Point(p) = {0, 0, eb, lc};
Point(p+1) = {er, 0, eb, lc};
Point(p+2) = {0, er, eb, lc};
Point(p+3) = {-er, 0, eb, lc};
Point(p+4) = {0, -er, eb, lc};
//+
c = newc;
Circle(c) = {p+1, p, p+2};
Circle(c+1) = {p+2, p, p+3};
Circle(c+2) = {p+3, p, p+4};
Circle(c+3) = {p+4, p, p+1};
//+
ll = newll;
Line Loop(ll) = {c, c+1, c+2, c+3};
//+
s = news;
Surface(s) = {ll};
//+
tmp[] = Extrude {0, 0, -eh} { Surface{s}; };
vol_eddy = tmp[1];
//+
Surface Loop(1) = {108, 95, 86, 99, 103, 107};
//+
Surface Loop(2) = {27, 10, 23, 52, 31, 35, 39, 43, 47, 51};
//+
Surface Loop(3) = {80, 67, 58, 71, 75, 79};
//+
Surface Loop(4) = {127, 114, 123, 136, 131, 135};
//+
Volume(100) = {1, 2, 3, 4};

Physical Volume(AIR) = {100};
Physical Volume(ICORE) = vol_core[];
Physical Volume(COIL) = vol_coil[];
Physical Volume(ECORE) = vol_eddy[];

Physical Surface(SKINECORE) = CombinedBoundary{Volume{vol_eddy[]};};
Physical Surface(SKINICORE) = CombinedBoundary{Volume{vol_core[]};};
Physical Surface(SKINCOIL) = CombinedBoundary{Volume{vol_coil[]};};
Physical Surface(SURF_AIROUT) = CombinedBoundary{Volume{vol_box[]};};
